diff -uwrN sourceold/scripts/engine_obj.h source/scripts/engine_obj.h
--- sourceold/scripts/engine_obj.h	2012-04-24 13:38:29.723632800 +0800
+++ source/scripts/engine_obj.h	2012-07-28 09:11:06.362304600 +0800
@@ -73,7 +73,7 @@
 void SCRIPTS_API Set_Powerup_Always_Allow_Grant(GameObject *obj,bool Grant); //Change if this powerup is set to always allows grant
 int SCRIPTS_API Get_Powerup_Grant_Sound(GameObject *obj); //Returns the sound that is played when this powerup is picked up
 void SCRIPTS_API Grant_Powerup(GameObject *obj,const char *Preset_Name); //grants a powerup
-
+GameObject SCRIPTS_API *Find_Closest_Building(const Vector3& position); // Find the closest building
 Vector3 SCRIPTS_API Get_Velocity( GameObject* obj ); // Get the current velocity of a PhysicalGameObject
 void SCRIPTS_API Set_Velocity( GameObject* obj, Vector3 velocity ); // Set the velocity of a PhysicalGameObject
 Matrix3D SCRIPTS_API Get_Transform( GameObject* obj ); // Get the current transform of a PhysicalGameObject
diff -uwrN sourceold/scripts/engine_obj2.cpp source/scripts/engine_obj2.cpp
--- sourceold/scripts/engine_obj2.cpp	2012-05-23 11:29:54.504882800 +0800
+++ source/scripts/engine_obj2.cpp	2012-08-12 22:45:46.250484400 +0800
@@ -98,8 +98,32 @@
 	{
 		Vector3 v;
 		obj->Get_Position(&v);
+
+		if (Model)
+		{
+			static const float test_distance = 10000.f;
+			static const Vector3 test_direction(0, 0, 1);
+
+			LineSegClass line(v, test_direction, test_distance);
+			CastResultStruct result;
+			result.ComputeContactPoint = true;
+			RayCollisionTestClass test(line, &result, COLLISION_TYPE_PHYSICAL);
+			
+			int count = 0;
+			while (Model->Cast_Ray(test))
+			{
+				++count;
+				result.ContactPoint.Y += .000001f;
+				line.Set(result.ContactPoint, test_direction, test_distance);
+			}
+			
+			return count & 1;
+		}
+		else
+		{
 		return CollisionMath::Overlap_Test(BoundingBox,v) == CollisionMath::INSIDE;
 	}
+	}
 	else
 	{
 		return false;
diff -uwrN sourceold/scripts/engine_tt.cpp source/scripts/engine_tt.cpp
--- sourceold/scripts/engine_tt.cpp	2012-05-28 21:47:07.366210900 +0800
+++ source/scripts/engine_tt.cpp	2012-08-24 20:46:44.473632800 +0800
@@ -156,6 +156,8 @@
 SCRIPTS_API gml Get_Mine_Limit;
 SCRIPTS_API sbd Set_Special_Base_Destruction;
 SCRIPTS_API gpv Get_Client_Version;
+SCRIPTS_API gpr Get_Client_Revision;
+SCRIPTS_API gpr Get_Revision;
 SCRIPTS_API gdw Get_Damage_Warhead;
 SCRIPTS_API ggobpn Get_GameObj_By_Player_Name;
 SCRIPTS_API scap Send_Custom_All_Players;
@@ -168,6 +170,10 @@
 SCRIPTS_API gcsh Get_Client_Serial_Hash;
 SCRIPTS_API gml Get_Tech_Level;
 SCRIPTS_API sw Set_Tech_Level;
+SCRIPTS_API cee Create_Explosion_Extended;
+SCRIPTS_API rwpa Retrieve_Waypaths;
+SCRIPTS_API rwpo Retrieve_Waypoints;
+SCRIPTS_API gwp Get_Waypoint_Position;
 
 SCRIPTS_API bool Can_Team_Build_Vehicle(int Team)
 {
@@ -934,11 +940,11 @@
 	}
 }
 
-SCRIPTS_API void cNetEvent::Set_Object_Dirty_Bit_For_Version(float version,DIRTY_BIT dirty_bit, bool onoff)
+SCRIPTS_API void cNetEvent::Set_Object_Dirty_Bit_For_Revision(uint revision,DIRTY_BIT dirty_bit, bool onoff)
 {
 	for (int clientId = 1; clientId < 128; ++clientId)
 	{
-		if (Get_Client_Version(clientId) >= version)
+		if (Get_Client_Revision(clientId) >= revision)
 		{
 			Set_Object_Dirty_Bit(clientId,dirty_bit,onoff);
 		}
diff -uwrN sourceold/scripts/engine_tt.h source/scripts/engine_tt.h
--- sourceold/scripts/engine_tt.h	2012-05-28 21:47:07.505859300 +0800
+++ source/scripts/engine_tt.h	2012-08-24 20:46:44.416015600 +0800
@@ -119,6 +119,7 @@
 typedef int (*gml) ();
 typedef void (*sbd) ();
 typedef float (*gpv) (int playerId);
+typedef uint (*gpr) (int playerId);
 typedef unsigned int (*gdw) ();
 typedef void (*naee) (GameObject * obj, const ActionParamsStruct & params);
 typedef GameObject *(*ggobpn) (const char *name);
@@ -137,6 +138,10 @@
 typedef cScTextObj *(*sct) (const WideStringClass& message, TextMessageEnum type, bool popup, int senderId, int receiverId, bool dodirtybit, bool doact);
 typedef SCAnnouncement *(*sca) (int _receiptientId, int _senderId, int _translationId, AnnouncementEnum _type, int _emoticonId, bool dodirtybit, bool doact);
 typedef bool (*iwu) (wchar_t *WideName);
+typedef void (*cee) (const char *Explosion, Vector3 &Pos, GameObject *Creator);
+typedef void (*rwpa) (DynamicVectorClass<int> &WaypathIDs);
+typedef void (*rwpo) (int WaypathID, DynamicVectorClass<int> &WaypointIDs);
+typedef void (*gwp) (int WaypathID, int WaypointID, Vector3 &Pos);
 SCRIPTS_API extern gpl Get_Player_List;
 SCRIPTS_API extern gcmi Get_Current_Map_Index;
 SCRIPTS_API extern gm Get_Map;
@@ -265,12 +270,18 @@
 SCRIPTS_API extern gml Get_Mine_Limit;
 SCRIPTS_API extern sbd Set_Special_Base_Destruction;
 SCRIPTS_API extern gpv Get_Client_Version;
+SCRIPTS_API extern gpr Get_Client_Revision;
+SCRIPTS_API extern gpr Get_Revision;
 SCRIPTS_API extern gdw Get_Damage_Warhead;
 SCRIPTS_API extern addConnectionAcceptanceFilterType addConnectionAcceptanceFilter;
 SCRIPTS_API extern removeConnectionAcceptanceFilterType removeConnectionAcceptanceFilter;
 SCRIPTS_API extern iwu Is_WOL_User;
 SCRIPTS_API extern gml Get_Tech_Level;
 SCRIPTS_API extern sw Set_Tech_Level;
+SCRIPTS_API extern cee Create_Explosion_Extended;
+SCRIPTS_API extern rwpa Retrieve_Waypaths;
+SCRIPTS_API extern rwpo Retrieve_Waypoints;
+SCRIPTS_API extern gwp Get_Waypoint_Position;
 
 class SCRIPTS_API JFW_Key_Hook_Base : public ScriptImpClass {
 public:
diff -uwrN sourceold/scripts/gmgame.cpp source/scripts/gmgame.cpp
--- sourceold/scripts/gmgame.cpp	2012-05-16 00:26:42.453125000 +0800
+++ source/scripts/gmgame.cpp	2012-07-28 09:11:06.221679600 +0800
@@ -1201,6 +1201,7 @@
 
 void SSGM_Log_Beacon::Created(GameObject *obj)
 {
+	killed = false;
 	triggerrepairing = true;
 	Vector3	pos	= Commands->Get_Position(obj);
 	SSGMGameLog::Log_Gamelog("CREATED;OBJECT;%d;%s;%d;%d;%d;%d;%d;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(pos.Y),int(pos.X),int(pos.Z),	int(Commands->Get_Facing(obj)),	int(Commands->Get_Max_Health(obj)),int(Commands->Get_Max_Shield_Strength(obj)),	Commands->Get_Player_Type(obj),Commands->Get_ID(Get_Beacon_Planter(obj)));
@@ -1208,6 +1209,13 @@
 
 void SSGM_Log_Beacon::Destroyed(GameObject *obj)
 {
+	if (!killed)
+	{
+		StringClass str3;
+		const char *str4 = Get_Translated_Preset_Name_Ini(obj);
+		str3.Format("%s has detonated",str4);
+		SSGMGameLog::Log_Message(str3,"_BEACON");
+	}
 	Vector3	pos	= Commands->Get_Position(obj);
 	SSGMGameLog::Log_Gamelog("DESTROYED;OBJECT;%d;%s;%d;%d;%d", Commands->Get_ID(obj),Commands->Get_Preset_Name(obj), int(pos.Y), int(pos.X), int(pos.Z));
 }
@@ -1227,13 +1235,6 @@
 
 void SSGM_Log_Beacon::Damaged(GameObject *obj, GameObject *damager, float amount)
 {
-	if (amount == 0 && damager == Get_Beacon_Planter(obj))
-	{
-		StringClass str3;
-		const char *str4 = Get_Translated_Preset_Name_Ini(obj);
-		str3.Format("%s has detonated",str4);
-		SSGMGameLog::Log_Message(str3,"_BEACON");
-	}
 	if (amount != 0)
 	{
 		Vector3	victimpos =	Commands->Get_Position(obj);
@@ -1261,6 +1262,7 @@
 
 void SSGM_Log_Beacon::Killed(GameObject *obj, GameObject *killer)
 {
+	killed = true;
 	Vector3	victimpos =	Commands->Get_Position(obj);
 	Vector3	damagerpos = Commands->Get_Position(killer);
 	const char *str = Get_Translated_Preset_Name_Ex(obj);
diff -uwrN sourceold/scripts/gmgame.h source/scripts/gmgame.h
--- sourceold/scripts/gmgame.h	2012-05-16 00:26:41.498046800 +0800
+++ source/scripts/gmgame.h	2012-07-28 09:11:06.667968700 +0800
@@ -60,6 +60,7 @@
 	void Timer_Expired(GameObject *obj, int number);
 	public: void Register_Auto_Save_Variables();
 	bool triggerrepairing;
+	bool killed;
 };
 
 class SSGM_Log_Mine : public ScriptImpClass {
diff -uwrN sourceold/scripts/gmlog.cpp source/scripts/gmlog.cpp
--- sourceold/scripts/gmlog.cpp	2012-04-14 04:09:48.107421800 +0800
+++ source/scripts/gmlog.cpp	2012-08-13 00:16:37.022945400 +0800
@@ -66,44 +66,35 @@
 		Connection *c = new Connection;
 		c->cbufferFilled = 0;
 		c->socket = so;
+		c->cbuffer[_countof(c->cbuffer)-1] = '\0';
 		Connections.Add(c);
 	}
-	for (int i = 0;i < Connections.Count();i++)
+	for (int i = 0; i < Connections.Count(); ++i)
 	{
-		char* bufferPtr = Connections[i]->cbuffer + Connections[i]->cbufferFilled;
-		int chars_read = recv(Connections[i]->socket, bufferPtr, sizeof(Connections[i]->cbuffer)-Connections[i]->cbufferFilled,0);
-		if( !(chars_read > 0) && WSAGetLastError() != WSAEWOULDBLOCK )
+		int chars_read = recv(Connections[i]->socket, Connections[i]->cbuffer + Connections[i]->cbufferFilled, _countof(Connections[i]->cbuffer)-1 - Connections[i]->cbufferFilled, 0);
+		if (chars_read == 0 || (chars_read == SOCKET_ERROR && WSAGetLastError() != WSAEWOULDBLOCK)) // Graceful close or error. Note that if the buffer is full, 0 bytes are read, and this is interpreted as a graceful close too!
 		{
-			// Bot has closed the socket or something has gone wrong, you should deal with that here
 			closesocket(Connections[i]->socket);
 			Connections.Delete(Connections[i]);
-			continue;
 		}
-		if (!(chars_read > 0))
+		else if (chars_read > 0) // Data received
 		{
-			continue;
+			char* lineStartPos = Connections[i]->cbuffer;
+			char* endPos = Connections[i]->cbuffer + Connections[i]->cbufferFilled + chars_read;
+			for (;;)
+			{
+				TT_ASSERT(endPos >= lineStartPos);
+				char* lineEndPos = (char*)memchr(lineStartPos, '\n', endPos - lineStartPos);
+				if (!lineEndPos) break;
+				*lineEndPos = '\0';
+				if (lineEndPos - lineStartPos > 0 && *(lineEndPos-1) == '\r') *(lineEndPos-1) = '\0'; // Remove trailing \r if CRLF line endings are used.
+				Console_Input(lineStartPos);
+				lineStartPos = lineEndPos+1;
+			}
+			TT_ASSERT(endPos - lineStartPos >= 0);
+			Connections[i]->cbufferFilled = endPos - lineStartPos;
+			memmove(Connections[i]->cbuffer, lineStartPos, endPos - lineStartPos);
 		}
-		Connections[i]->cbufferFilled += chars_read;
-		// Look for complete messages in buffer
-		char *startPos = Connections[i]->cbuffer;
-		char *endPos = Connections[i]->cbuffer;
-		endPos = strchr ( startPos, '\n' );
-		while ( (endPos) && (Connections[i]->cbufferFilled > 0) )
-		{
-			// Copy input to message
-			int messageLength = (endPos-startPos);
-			char* message = new char[messageLength+1];
-			strncpy ( message, startPos, messageLength );
-			message[messageLength] = '\0';
-			// Call a function to do something with message
-			Console_Input(message);
-			// Clean up message
-			delete [] message;
-			Connections[i]->cbufferFilled -= (++endPos - startPos);
-			startPos = endPos;
-			endPos = strchr ( startPos, '\n' );
-		}
-		memmove(Connections[i]->cbuffer,startPos,Connections[i]->cbufferFilled);
 	}
 }
 
diff -uwrN sourceold/scripts/gmsoldier.cpp source/scripts/gmsoldier.cpp
--- sourceold/scripts/gmsoldier.cpp	2012-05-23 10:18:54.079101500 +0800
+++ source/scripts/gmsoldier.cpp	2012-08-05 11:28:50.059554700 +0800
@@ -129,7 +129,7 @@
 
 void SSGM_Soldier::Detach(GameObject *obj)
 {
-	Unbind_Vehicle(obj, true);
+	//Unbind_Vehicle(obj, true);
 }
 
 void SSGM_Soldier::Destroyed(GameObject *obj)
@@ -280,7 +280,7 @@
 		StringClass str;
 		const char *str2 = Get_Translated_Preset_Name_Ex(obj);
 		const char *str3 = Get_Player_Name(obj);
-		str.Format("%s killed their own dumb self (%s)",str3,str2);
+		str.Format("%s killed their self (%s)",str3,str2);
 		delete[] str2;
 		delete[] str3;
 		SSGMGameLog::Log_Message(str,"_PLAYERKILL");
@@ -330,7 +330,7 @@
 		else if (Commands->Get_ID(obj) == Commands->Get_ID(killer))
 		{
 			StringClass str;
-			str.Format("%ls killed their own dumb self",Get_Wide_Player_Name(obj));
+			str.Format("%ls killed their self",Get_Wide_Player_Name(obj));
 			Send_Message_With_Team_Color(Get_Object_Type(obj),str);
 		}
 		else if (!Commands->Is_A_Star(killer))
diff -uwrN sourceold/scripts/jfwdmg.h source/scripts/jfwdmg.h
--- sourceold/scripts/jfwdmg.h	2012-04-14 04:09:46.730468700 +0800
+++ source/scripts/jfwdmg.h	2012-07-28 09:11:05.329101500 +0800
@@ -10,28 +10,129 @@
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
 #pragma once
+
+// -------------------------------------------------------------------------------------------------
+
+/*!
+*\ brief Spawns a new object when an object is killed
+* \author jonwil
+*
+* When the object this script is attached to is killed it will spawn a new object at the location it
+* was killed. This is useful for spawning a destroyed version of an object.
+*
+* \param Drop_Object
+*   Name of the preset to be created when the object is killed
+* \param Drop_Height
+*   Height above the location where the object was killed to spawn the new object, or 0 to spawn it
+*   at the same height as the object was killed. Can also be negative. Helps to prevent issues with
+*   terrain clipping when the destroyed object has a different origin point
+*
+* \note
+*   The object the script is attached to must be killed through damage applied to it for this script
+*   to work. If the object is simply destroyed (such as by JFW_Destroy_Self_Timer) no object will be
+*   spawned.
+*/
 class JFW_Spawn_Object_Death : public ScriptImpClass {
 	void Killed(GameObject *obj,GameObject *killer);
 };
 
+// -------------------------------------------------------------------------------------------------
+
+/*!
+* \brief Destroys a building by applying damage after a fixed period of time
+* \author jonwil
+*
+* This script will apply 10,000 damage using the <b>Explosive</b> warhead to the object it is
+* attached to after a specified number of seconds has elapsed, which is sufficient to destroy
+* any standard building in Renegade.
+*
+* \note
+*   Although the script is intended for use with buildings it will actually work on any damagable
+*   game object
+*
+* \pre
+*   Requires a warhead called <b>Explosive</b> to be defined in armor.ini. This is already present
+*   in stock versions of Renegade but may not exist in total conversion modifications.
+*
+* \param Time
+*   Number of seconds to wait before triggering
+* \param TimerNum
+*   Internal ID to use for the timer to avoid clashing with any other timers on the same object
+*/
 class JFW_Timer_Destroy_Building : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 };
 
+// -------------------------------------------------------------------------------------------------
+
+/*!
+* \brief Destroys an object by applying damage after a fixed period of time
+* \author jonwil
+*
+* This script will apply a specified amount of damage with a specified warhead to the object it is
+* attached to after a specified number of seconds has elapsed.
+*
+* \note
+*   Although the script name implies it is purely for destroying objects it can also be used to
+*   apply a fixed amount of damage with a particular warhead to an object if the specified amount of
+*   damage is insufficient to kill the object.
+*
+* \param Time
+*   Number of seconds to wait before triggering
+* \param Amount
+*   Amount of damage to apply to the object the script is attached to
+* \param Warhead
+*   Warhead to use when applying damage, typically <b>Death</b> is a good choice here
+*/
 class JFW_Timer_Destroy_Object : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 };
 
+// -------------------------------------------------------------------------------------------------
+
+/*!
+* \brief Creates an explosion when an object is killed
+* \author jonwil
+*
+* When the object this script is attached to is killed it will create an explosion at the location
+* it was killed.
+*
+* \param Explosion
+*   Preset name of the explosion to be created
+*
+* \note
+*   The object the script is attached to must be killed through damage applied to it for this script
+*   to work. If the object is simply destroyed (such as by JFW_Destroy_Self_Timer) no explosion will
+*   be created.
+*/
 class JFW_Blow_Up_On_Death : public ScriptImpClass {
 	void Killed(GameObject *obj,GameObject *killer);
 };
 
+// -------------------------------------------------------------------------------------------------
+
+/*!
+* \brief Grants extra points when an object is killed
+* \author jonwil
+*
+* When the object this script is attached to is killed by the specified team it will grant points to
+* the killer and, optionally, every other player on the killers team.
+* 
+* \param Player_Type
+*   Team the killer must be on to recieve points (0 = Nod, 1 = GDI, 2 = Either)
+* \param Points
+*   Number of points to give when this object is killed
+* \param Whole_Team
+*   0 to grant points to the killer only, 1 to give points to their whole team
+*/
 class JFW_Give_Points_On_Death : public ScriptImpClass {
 	void Killed(GameObject *obj,GameObject *killer);
 };
 
+// -------------------------------------------------------------------------------------------------
+
 class JFW_Armour_Regen : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
@@ -218,6 +319,24 @@
 	void Timer_Expired(GameObject *obj,int number);
 };
 
+/*!
+* \brief Destroys an object after a fixed period of time
+* \author jonwil
+*
+* This script will destroy the object it is attached to after a specified number of seconds has
+* elapsed.
+*
+* \warning
+*   Because the object is destroyed (by using ScriptCommands::Destroy_Object()) rather than killed
+*   by damage the GameObjObserverClass::Killed() callback will not be trigger for any other scripts
+*   attached to the object, which may cause unexpected behaviour. If you need to ensure the callback
+*   is executed consider using JFW_Timer_Destroy_Object instead.
+*
+* \param Time
+*   Number of seconds to wait before triggering
+* \param TimerNum
+*   Internal ID to use for the timer to avoid clashing with any other timers on the same object
+*/
 class JFW_Destroy_Self_Timer : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
diff -uwrN sourceold/scripts/jfwsnd.cpp source/scripts/jfwsnd.cpp
--- sourceold/scripts/jfwsnd.cpp	2012-05-28 09:47:05.897078200 +0800
+++ source/scripts/jfwsnd.cpp	2012-07-28 09:11:06.284179600 +0800
@@ -218,7 +218,7 @@
 
 void JFW_2D_Sound_Damage_Range::Damaged(GameObject *obj,GameObject *damager,float amount)
 {
-	if ((Commands->Get_Health(obj) <= Get_Float_Parameter("MaxHealth")) && (Commands->Get_Health(obj) >= Get_Float_Parameter("MinHealth")))
+	if (Commands->Get_Health(obj) <= Get_Float_Parameter("MinHealth"))
 	{
 		if (enabled)
 		{
@@ -226,7 +226,7 @@
 			Commands->Create_2D_Sound(Get_Parameter("Sound"));
 		}
 	}
-	else
+	else if (Commands->Get_Health(obj) >= Get_Float_Parameter("MaxHealth"))
 	{
 		enabled = true;
 	}
@@ -244,7 +244,7 @@
 
 void JFW_2D_Sound_Damage_Range_Team::Damaged(GameObject *obj,GameObject *damager,float amount)
 {
-	if ((Commands->Get_Health(obj) <= Get_Float_Parameter("MaxHealth")) && (Commands->Get_Health(obj) >= Get_Float_Parameter("MinHealth")))
+	if (Commands->Get_Health(obj) <= Get_Float_Parameter("MinHealth"))
 	{
 		if (enabled)
 		{
@@ -252,7 +252,7 @@
 			Create_2D_Sound_Team(Get_Parameter("Sound"),Get_Object_Type(obj));
 		}
 	}
-	else
+	else if (Commands->Get_Health(obj) >= Get_Float_Parameter("MaxHealth"))
 	{
 		enabled = true;
 	}
@@ -272,7 +272,7 @@
 extern REF_DECL2(GDIHouseColor, Vector3);
 void JFW_2D_Sound_Damage_Range_Team_String::Damaged(GameObject *obj,GameObject *damager,float amount)
 {
-	if ((Commands->Get_Health(obj) <= Get_Float_Parameter("MaxHealth")) && (Commands->Get_Health(obj) >= Get_Float_Parameter("MinHealth")))
+	if (Commands->Get_Health(obj) <= Get_Float_Parameter("MinHealth"))
 	{
 		if (enabled)
 		{
@@ -296,7 +296,7 @@
 			Send_Message_Team(Get_Object_Type(obj),red,green,blue,Get_Parameter("String"));
 		}
 	}
-	else
+	else if (Commands->Get_Health(obj) >= Get_Float_Parameter("MaxHealth"))
 	{
 		enabled = true;
 	}
@@ -314,7 +314,7 @@
 
 void JFW_3D_Sound_Damage_Range::Damaged(GameObject *obj,GameObject *damager,float amount)
 {
-	if ((Commands->Get_Health(obj) <= Get_Float_Parameter("MaxHealth")) && (Commands->Get_Health(obj) >= Get_Float_Parameter("MinHealth")))
+	if (Commands->Get_Health(obj) <= Get_Float_Parameter("MinHealth"))
 	{
 		if (enabled)
 		{
@@ -327,7 +327,7 @@
 			Commands->Create_Sound(Get_Parameter("Sound"),pos,obj);
 		}
 	}
-	else
+	else if (Commands->Get_Health(obj) >= Get_Float_Parameter("MaxHealth"))
 	{
 		enabled = true;
 	}
diff -uwrN sourceold/scripts/jfwweap.cpp source/scripts/jfwweap.cpp
--- sourceold/scripts/jfwweap.cpp	2012-04-14 04:09:47.826171800 +0800
+++ source/scripts/jfwweap.cpp	2012-08-21 22:31:21.856445300 +0800
@@ -14,6 +14,7 @@
 #include "scripts.h"
 #include "engine.h"
 #include "jfwweap.h"
+#include "VehicleGameObj.h"
 
 void JFW_Nod_Turret::Created(GameObject *obj)
 {
@@ -1349,6 +1350,124 @@
 	}
 }
 
+void JFW_Vehicle_Weapon_Switcher::Created(GameObject *obj)
+{
+	switching = false;
+	newweap = false;
+	pilotID = 0;
+	new_weapon = 0;
+	old_weapon = 0;
+	Commands->Give_PowerUp(obj,Get_Parameter("Powerup"),false);
+	new_weapon = Get_Powerup_Weapon(Get_Parameter("PowerUp"));
+	hookid = 0;
+	k = 0;
+}
+
+void JFW_Vehicle_Weapon_Switcher::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == CUSTOM_EVENT_VEHICLE_ENTERED)
+	{
+		if (!pilotID)
+		{
+			InstallHook(Get_Parameter("Keyhook"),sender);
+			pilotID = Commands->Get_ID(sender);
+		}
+	}
+	if (type == CUSTOM_EVENT_VEHICLE_EXITED)
+	{
+		if (pilotID == Commands->Get_ID(sender))
+		{
+			RemoveHook();
+			pilotID = 0;
+		}
+	}
+}
+
+void JFW_Vehicle_Weapon_Switcher::Killed(GameObject *obj,GameObject *killer)
+{
+	RemoveHook();
+}
+
+void JFW_Vehicle_Weapon_Switcher::Timer_Expired(GameObject *obj,int number)
+{
+	switching = false;
+	obj->As_VehicleGameObj()->Set_Scripts_Can_Fire(true);
+	if (newweap)
+	{
+		old_weapon = newstr(Get_Current_Weapon(obj));
+		Commands->Select_Weapon(obj,new_weapon);
+	}
+	else
+	{
+		Commands->Select_Weapon(obj,old_weapon);
+		old_weapon = 0;
+	}
+}
+
+void JFW_Vehicle_Weapon_Switcher::KeyHook()
+{
+	if (switching)
+	{
+		return;
+	}
+	VehicleGameObj *obj = Owner()->As_VehicleGameObj();
+	obj->Set_Scripts_Can_Fire(false);
+	switching = true;
+	if (newweap)
+	{
+		newweap = false;
+		Commands->Create_Sound(Get_Parameter("OldSound"),Commands->Get_Position(obj),0);
+	}
+	else
+	{
+		newweap = true;
+		Commands->Create_Sound(Get_Parameter("NewSound"),Commands->Get_Position(obj),0);
+	}
+	Commands->Start_Timer(obj,this,Get_Float_Parameter("SwitchTime"),1);
+}
+
+void JFW_Char_Weapon_Switcher::Created(GameObject *obj)
+{
+	LastSwitch = 0;
+	Weapon2 = true;
+	InstallHook(Get_Parameter("Keyhook"),obj);
+}
+
+void JFW_Char_Weapon_Switcher::KeyHook()
+{
+	if (time(NULL) - LastSwitch < Get_Float_Parameter("SwitchTime"))
+	{
+		StringClass str;
+		str.Format("You cannot switch weapons yet, you must wait at least %f seconds after switching to switch again.",Get_Float_Parameter("SwitchTime"));
+		Send_Message_Player(Owner(),153,204,25,str);
+		return;
+	}
+	LastSwitch = time(NULL);
+	if (Weapon2)
+	{
+		Remove_Weapon(Owner(),Get_Powerup_Weapon(Get_Parameter("WeaponPowerup2")));
+	}
+	else
+	{
+		Remove_Weapon(Owner(),Get_Powerup_Weapon(Get_Parameter("WeaponPowerup1")));
+	}
+	Commands->Start_Timer(Owner(),this,Get_Float_Parameter("SwitchTime"),1);
+}
+
+void JFW_Char_Weapon_Switcher::Timer_Expired(GameObject *obj,int number)
+{
+	if (Weapon2)
+	{
+		Commands->Give_PowerUp(obj,Get_Parameter("WeaponPowerup2"),false);
+		Commands->Select_Weapon(obj,Get_Powerup_Weapon(Get_Parameter("WeaponPowerup2")));
+	}
+	else
+	{
+		Commands->Give_PowerUp(obj,Get_Parameter("WeaponPowerup1"),false);
+		Commands->Select_Weapon(obj,Get_Powerup_Weapon(Get_Parameter("WeaponPowerup1")));
+	}
+}
+
 ScriptRegistrant<JFW_Nod_Turret> JFW_Nod_Turret_Registrant("JFW_Nod_Turret","");
 ScriptRegistrant<JFW_Nod_Obelisk_CnC> JFW_Nod_Obelisk_CnC_Registrant("JFW_Nod_Obelisk_CnC","Controller_ID=0:int");
 ScriptRegistrant<JFW_Obelisk_Weapon_CnC> JFW_Obelisk_Weapon_CnC_Registrant("JFW_Obelisk_Weapon_CnC","");
@@ -1371,3 +1490,5 @@
 ScriptRegistrant<JFW_Weapon_Change_On_Custom_Multiple> JFW_Weapon_Change_On_Custom_Multiple_Registrant("JFW_Weapon_Change_On_Custom_Multiple","Message:int,Powerup1:string,Powerup2:string,Powerup3:string,Powerup4:string,Powerup5:string,Weapon:string");
 ScriptRegistrant<JFW_Weapon_Change_On_Custom_Multiple_Sender> JFW_Weapon_Change_On_Custom_Multiple_Sender_Registrant("JFW_Weapon_Change_On_Custom_Multiple_Sender","Message:int,Powerup1:string,Powerup2:string,Powerup3:string,Powerup4:string,Powerup5:string,Weapon:string");
 ScriptRegistrant<JFW_Fire_Weapon_Custom> JFW_Fire_Weapon_Custom_Registrant("JFW_Fire_Weapon_Custom","Target:vector3,Custom:int");
+ScriptRegistrant<JFW_Vehicle_Weapon_Switcher> JFW_Vehicle_Weapon_Switcher_Registrant("JFW_Vehicle_Weapon_Switcher","Powerup:string,Keyhook=VDeploy:string,SwitchTime:float,OldSound:string,NewSound:string");
+ScriptRegistrant<JFW_Char_Weapon_Switcher> JFW_Char_Weapon_Switcher_Registrant("JFW_Char_Weapon_Switcher","SwitchTime:float,WeaponPowerup1:string,WeaponPowerup2:string,Keyhook:string");
diff -uwrN sourceold/scripts/jfwweap.h source/scripts/jfwweap.h
--- sourceold/scripts/jfwweap.h	2012-04-14 04:09:47.764648400 +0800
+++ source/scripts/jfwweap.h	2012-08-21 22:29:58.359375000 +0800
@@ -163,3 +163,24 @@
 class JFW_Fire_Weapon_Custom : public ScriptImpClass {
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 };
+
+class JFW_Vehicle_Weapon_Switcher : public JFW_Key_Hook_Base {
+	bool switching;
+	bool newweap;
+	int pilotID;
+	const char *new_weapon;
+	const char *old_weapon;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Killed(GameObject *obj,GameObject *killer);
+	void Timer_Expired(GameObject *obj,int number);
+	void KeyHook();
+};
+
+class JFW_Char_Weapon_Switcher : public JFW_Key_Hook_Base {
+	time_t LastSwitch;
+	bool Weapon2;
+	void Created( GameObject *obj );
+	void KeyHook();
+	void Timer_Expired( GameObject *obj,int number );
+};
diff -uwrN sourceold/scripts/scripts.vcxproj source/scripts/scripts.vcxproj
--- sourceold/scripts/scripts.vcxproj	2012-06-09 08:11:12.138671800 +0800
+++ source/scripts/scripts.vcxproj	2012-08-10 16:07:34.253906200 +0800
@@ -500,9 +500,15 @@
     <ClCompile Include="tcw_game.cpp" />
     <ClCompile Include="tcw_general.cpp" />
     <ClCompile Include="tcw_mcv_escort.cpp" />
+    <ClCompile Include="tcw_mission01.cpp" />
+    <ClCompile Include="tcw_mission03.cpp" />
+    <ClCompile Include="tcw_nod_incursion.cpp" />
+    <ClCompile Include="tcw_paul.cpp" />
     <ClCompile Include="tcw_player.cpp" />
     <ClCompile Include="tcw_powerup.cpp" />
     <ClCompile Include="tcw_raid_at_dawn.cpp" />
+    <ClCompile Include="tcw_sp_m01.cpp" />
+    <ClCompile Include="tcw_sp_scripts.cpp" />
     <ClCompile Include="tcw_superweapons.cpp" />
     <ClCompile Include="tcw_TCWSoldierObj.cpp" />
     <ClCompile Include="tcw_technology.cpp" />
@@ -512,6 +518,7 @@
     <ClCompile Include="tda.cpp" />
     <ClCompile Include="tfx.cpp" />
     <ClCompile Include="ThreadClass.cpp" />
+    <ClCompile Include="xpert.cpp" />
     <ClCompile Include="z.cpp" />
     <ClCompile Include="z_airraid.cpp" />
     <ClCompile Include="z_am01.cpp" />
@@ -793,9 +800,15 @@
     <ClInclude Include="tcw_game.h" />
     <ClInclude Include="tcw_general.h" />
     <ClInclude Include="tcw_mcv_escort.h" />
+    <ClInclude Include="tcw_mission01.h" />
+    <ClInclude Include="tcw_mission03.h" />
+    <ClInclude Include="tcw_nod_incursion.h" />
+    <ClInclude Include="tcw_paul.h" />
     <ClInclude Include="tcw_player.h" />
     <ClInclude Include="tcw_powerup.h" />
     <ClInclude Include="tcw_raid_at_dawn.h" />
+    <ClInclude Include="tcw_sp_m01.h" />
+    <ClInclude Include="tcw_sp_scripts.h" />
     <ClInclude Include="tcw_superweapons.h" />
     <ClInclude Include="tcw_TCWSoldierObj.h" />
     <ClInclude Include="tcw_technology.h" />
@@ -821,6 +834,7 @@
     <ClInclude Include="weaponmgr.h" />
     <ClInclude Include="WidgetUserClass.h" />
     <ClInclude Include="WWAudioClass.h" />
+    <ClInclude Include="xpert.h" />
     <ClInclude Include="z.h" />
     <ClInclude Include="z_airraid.h" />
     <ClInclude Include="z_am01.h" />
diff -uwrN sourceold/scripts/scripts.vcxproj.filters source/scripts/scripts.vcxproj.filters
--- sourceold/scripts/scripts.vcxproj.filters	2012-06-09 08:11:12.155273400 +0800
+++ source/scripts/scripts.vcxproj.filters	2012-08-05 10:29:24.424789000 +0800
@@ -36,6 +36,12 @@
     <Filter Include="01. Sources\UberAOW">
       <UniqueIdentifier>{801d5c01-d34a-4efe-8732-24c88360c57e}</UniqueIdentifier>
     </Filter>
+    <Filter Include="01. Sources\Tib. Crystal War\Campaign">
+      <UniqueIdentifier>{ba24906d-1b40-49a7-aa3d-da4d65476041}</UniqueIdentifier>
+    </Filter>
+    <Filter Include="02. Headers\Tib. Crystal War\Campaign">
+      <UniqueIdentifier>{694fc3c1-10b6-4967-a04e-8983bdf5cc06}</UniqueIdentifier>
+    </Filter>
   </ItemGroup>
   <ItemGroup>
     <ClCompile Include="cAMpaScripts.cpp">
@@ -518,6 +524,27 @@
     <ClCompile Include="tcw_mcv_escort.cpp">
       <Filter>01. Sources\Tib. Crystal War</Filter>
     </ClCompile>
+    <ClCompile Include="xpert.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_mission01.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_mission03.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_nod_incursion.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_paul.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_sp_m01.cpp">
+      <Filter>01. Sources\Tib. Crystal War\Campaign</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_sp_scripts.cpp">
+      <Filter>01. Sources\Tib. Crystal War\Campaign</Filter>
+    </ClCompile>
   </ItemGroup>
   <ItemGroup>
     <ResourceCompile Include="scripts.rc">
@@ -1539,6 +1566,27 @@
     <ClInclude Include="tcw_mcv_escort.h">
       <Filter>02. Headers\Tib. Crystal War</Filter>
     </ClInclude>
+    <ClInclude Include="xpert.h">
+      <Filter>01. Sources</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_mission01.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_mission03.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_nod_incursion.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_paul.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_sp_m01.h">
+      <Filter>02. Headers\Tib. Crystal War\Campaign</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_sp_scripts.h">
+      <Filter>02. Headers\Tib. Crystal War\Campaign</Filter>
+    </ClInclude>
   </ItemGroup>
   <ItemGroup>
     <None Include="console.txt">
